/**
 *  Creator: Christian Hotz
 *  Company: hydra newmedia GmbH
 *  Date: 11.06.16
 *
 *  Copyright hydra newmedia GmbH
 */
/**
 *  Imports
 */
import { Entity } from '../utils/Entity';
import { Diff } from '../utils/Diff';
import { Snapshot } from '../utils/Snapshot';
import { Configuration } from '../utils/Configuration';
import { Creator } from '../utils/Creator';
import { EntryAppService } from '../appservices/EntryAppService';
import { StorageStrategy, FindDiffsCondition } from '../storage/StorageStrategy';
import { ChrobjectOptions } from '../utils/ChrobjectOptions';
export declare class Chrobject {
    entity: Entity;
    config: Configuration;
    appService: EntryAppService;
    constructor(entity: Entity, config: Configuration, storage: StorageStrategy, options?: ChrobjectOptions);
    getDiffs(condition: FindDiffsCondition, callback: (err: Error, diffs?: Diff[]) => void): void;
    getSnapshotById(id: string, callback: (err: Error, snapshot?: Snapshot) => void): void;
    saveEntry(obj: Object, creator: Creator, timestamp?: Date, callback?: (err: Error, result?: {
        snapshot?: Snapshot;
        diff?: Diff;
    }) => void): void;
}
